﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace fieldsBinding
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
            xamComparison.DataContext = new ViewModel();
        }
    }

    public class Result
    {
        public string Id { get; set; }

        public string Name { get; set; }

        public string Type { get; set; }

        public ReadOnlyObservableCollection<Result> Children { get; set; }

    }


    public class ViewModel
    {
        public ViewModel()
        {
            var collection = new ObservableCollection<Result>();
            collection.Add(new Result()
            {
                Id = "1",
                Name = "Name1",
                Type = "ComparisonNode",

                Children = CreateItem(new[]
                     {
                   new Result()
                   {
                       Id = "1.1",
                       Name = "Name 1.1",
                            Type = "ComparisonParameter",
                         }
               })
            });

            collection.Add(new Result()
            {
                Id = "2",
                Name = "Name2",
                Type = "ComparisonNode",
                Children = CreateItem(new[]
                {
                   new Result()
                   {
                       Id = "2.1",
                       Name = "Name 2.1",
                            Type = "ComparisonParameter",
                         },
                         new Result()
                         {
                              Id = "2.2",
                              Name = "Name 2.2",
                            Type = "ComparisonParameter",
                         }
                    })
            });

            collection.Add(new Result()
            {
                Id = "3",
                Name = "Name3",
                Type = "ComparisonNode",
                Children = CreateItem(new[]
                     {
                   new Result()
                   {
                       Id = "3.1",
                       Name = "Name 3.1",
                            Type = "ComparisonParameter",
                         }
               })
            });

            Nodes = new ReadOnlyObservableCollection<Result>(collection);
        }

        public ReadOnlyObservableCollection<Result> Nodes { get; set; }

        private ReadOnlyObservableCollection<Result> CreateItem(Result[] children)
        {
            var collection = new ObservableCollection<Result>(children);
            return new ReadOnlyObservableCollection<Result>(collection);
        }
    }


}
